#include <string.h>

#include "md5.h"
#include "tunes.h"

static struct MD5Context hash_context;
static unsigned char digest[16];

hashv_t
hash_string (const char *str)
{
  MD5Init (&hash_context);
  MD5Update (&hash_context, (const unsigned char *)str, strlen (str));
  MD5Final (digest, &hash_context);
  return (((hashv_t)digest[0])<<56)
    + (((hashv_t)digest[1])<<48)
    + (((hashv_t)digest[2])<<40)
    + (((hashv_t)digest[3])<<32)
    + (((hashv_t)digest[4])<<24)
    + (((hashv_t)digest[5])<<16)
    + (((hashv_t)digest[6])<<8)
    + ((hashv_t)digest[7]);
}
