#include <stdio.h>

#include "tunes.h"

void
no_error (const char *s)
{
  fprintf (stderr, "%s\n", s);
  exit (1);
}

void
error (const char *s)
{
  fprintf (stderr, "%s\n", s);
  exit (1);
}

int
main (void)
{
  may_gc = 0;
  /* Initialize registers: unit */
  gunit = a_unit ();
  task = gunit;
  expr = gunit;  env = gunit;  cont = gunit;
  erator = gunit;  erand = gunit;
  val = gunit;
  temp1 = gunit;  temp2 = gunit;  temp3 = gunit;  temp4 = gunit;
  /* mainprog */
  yyparse ();
  /* globenv */
  create_globenv ();
  /* final */
  final = allocate ();
  core[final].type = O_CONT_FINISH;
  /* curtask */
  expr = mainprog;
  env = globenv;
  cont = final;
  eval ();
  curtask = task;
  /* Now run the program */
  may_gc = 1;
  while ( 1 )
    step ();
  return 0;
}
