#include <stdio.h>

#include "tunes.h"

void
apply_pf_print (void)
{
  if ( core[erand].type == O_INT )
    printf ("%d\n", core[erand].d.int_v);
  else if ( core[erand].type == O_CHAR )
    printf ("%c", core[erand].d.char_v);
  else
    error ("Wrong type argument to primitive-function-print.");
  val = a_unit ();
  invoke ();
}

void
apply_pf_call_cc (void)
{
  task = allocate ();
  core[task].type = O_TASK_APPLY;
  core[task].d.task_apply_v.erator = erand;
  core[task].d.task_apply_v.erand = cont;
  core[task].d.task_apply_v.cont = cont;
}

void
apply_primfunc (primfunc_t fn)
{
  switch ( fn )
    {
    case PF_CALL_CC: apply_pf_call_cc (); break;
    case PF_PRINT: apply_pf_print (); break;
    default: error ("INTERNAL ERROR: Unknown primitive function type.");
    }
}
